#include <GPIO1.h>
#include <GPIO3.h>
#include "soes.h"

/**
 * This function reads the physical input "Buttons" and assigns
 * a value to the variable Rb.buttons.
 */
void cb_get_buttons()
{
	int sw1 = !GPIO1_GetFieldValue(GPIO1_DeviceData, SW1);
	int sw2 = !GPIO3_GetFieldValue(GPIO3_DeviceData, SW2);

	Rb.buttons = (sw2 << 1) | sw1;
}

/**
 * This function reads the physical input "Heartbeat" and assigns
 * a value to the variable Rb.heartbeat.
 */
void cb_get_heartbeat()
{
	Rb.heartbeat++;
}


/**
 * This function writes the physical output "LEDS" using the value
 * of the variable Wb.leds.
 */
void cb_set_leds()
{
	GPIO1_SetFieldValue(GPIO1_DeviceData, LEDBlue,   !((Wb.leds & 0x01) >> 0));
	GPIO1_SetFieldValue(GPIO1_DeviceData, LEDGreen,  !((Wb.leds & 0x02) >> 1));
	GPIO1_SetFieldValue(GPIO1_DeviceData, LEDYellow, !((Wb.leds & 0x04) >> 2));
	GPIO1_SetFieldValue(GPIO1_DeviceData, LEDOrange, !((Wb.leds & 0x08) >> 3));
}

/**
 * This function is called after a SDO write of the variable leds.
 */
void cb_post_write_leds()
{

}
