#ifndef __objectlist__
#define __objectlist__

typedef FLASHSTORE struct PACKED
{
   uint16 subindex;
   uint16 datatype;
   uint16 bitlength;
   uint16 access;
   char FLASHSTORE *name;
   uint32 value;
   void *data;
} _objd;

typedef FLASHSTORE struct PACKED
{
   uint16 index;
   uint16 objtype;
   uint8 maxsub;
   uint8 pad1;
   char FLASHSTORE *name;
   _objd FLASHSTORE *objdesc;
} _objectlist;

#define _ac FLASHSTORE char
#define nil 0

#define OTYPE_DOMAIN            0x0002
#define OTYPE_DEFTYPE           0x0005
#define OTYPE_DEFSTRUCT         0x0006
#define OTYPE_VAR               0x0007
#define OTYPE_ARRAY             0x0008
#define OTYPE_RECORD            0x0009

#define DTYPE_BOOLEAN           0x0001
#define DTYPE_INTEGER8          0x0002
#define DTYPE_INTEGER16         0x0003
#define DTYPE_INTEGER32         0x0004
#define DTYPE_UNSIGNED8         0x0005
#define DTYPE_UNSIGNED16        0x0006
#define DTYPE_UNSIGNED32        0x0007
#define DTYPE_REAL32            0x0008
#define DTYPE_VISIBLE_STRING    0x0009
#define DTYPE_OCTET_STRING      0x000A
#define DTYPE_UNICODE_STRING    0x000B
#define DTYPE_INTEGER24         0x0010
#define DTYPE_UNSIGNED24        0x0016
#define DTYPE_INTEGER64         0x0015
#define DTYPE_UNSIGNED64        0x001B
#define DTYPE_REAL64            0x0011
#define DTYPE_PDO_MAPPING       0x0021
#define DTYPE_IDENTITY          0x0023
#define DTYPE_BIT1              0x0030
#define DTYPE_BIT2              0x0031
#define DTYPE_BIT3              0x0032
#define DTYPE_BIT4              0x0033
#define DTYPE_BIT5              0x0034
#define DTYPE_BIT6              0x0035
#define DTYPE_BIT7              0x0036
#define DTYPE_BIT8              0x0037

#define ATYPE_RO                0x07
#define ATYPE_RW                0x3F
#define ATYPE_RWpre             0x0F
#define ATYPE_RXPDO             0x40
#define ATYPE_TXPDO             0x80

_ac acName1000[] = "Device Type";
_ac acName1000_0[] = "Device Type";
_ac acName1008[] = "Device Name";
_ac acName1008_0[] = "Device Name";
_ac acName1009[] = "Hardware Version";
_ac acName1009_0[] = "Hardware Version";
_ac acName100A[] = "Software Version";
_ac acName100A_0[] = "Software Version";
_ac acName1018[] = "Identity Object";
_ac acName1018_00[] = "Number of Elements";
_ac acName1018_01[] = "Vendor ID";
_ac acName1018_02[] = "Product Code";
_ac acName1018_03[] = "Revision Number";
_ac acName1018_04[] = "Serial Number";
_ac acName1600[] = "Receive PDO Mapping";
_ac acName1600_00[] = "Number of Elements";
_ac acName1600_01[] = "Mapped Object 1";
_ac acName1600_02[] = "Mapped Object 2";
_ac acName1A00[] = "Transmit PDO Mapping";
_ac acName1A00_00[] = "Number of Elements";
_ac acName1A00_01[] = "Mapped Object 1";
_ac acName1A00_02[] = "Mapped Object 2";
_ac acName1A00_03[] = "Mapped Object 3";
_ac acName1C00[] = "Sync Manager Communication Type";
_ac acName1C00_00[] = "Number of Elements";
_ac acName1C00_01[] = "Communications Type SM0";
_ac acName1C00_02[] = "Communications Type SM1";
_ac acName1C00_03[] = "Communications Type SM2";
_ac acName1C00_04[] = "Communications Type SM3";
_ac acName1C12[] = "Sync Manager 2 PDO Assignment";
_ac acName1C12_00[] = "Number of Elements";
_ac acName1C12_01[] = "PDO Mapping";
_ac acName1C13[] = "Sync Manager 3 PDO Assignment";
_ac acName1C13_00[] = "Number of Elements";
_ac acName1C13_01[] = "PDO Mapping";
_ac acName6000[] = "Inputs";
_ac acName6000_00[] = "Number of Elements";
_ac acName6000_01[] = "Buttons";
_ac acName6000_02[] = "Heartbeat";
_ac acName7000[] = "Outputs";
_ac acName7000_00[] = "Number of Elements";
_ac acName7000_01[] = "LEDS";

FLASHSTORE _objd SDO1000[] =
{
  {0x0, DTYPE_UNSIGNED32, 32, ATYPE_RO, acName1000_0, 0x01901389, nil},
};
FLASHSTORE _objd SDO1008[] =
{
  {0x0, DTYPE_VISIBLE_STRING, 40, ATYPE_RO, acName1008_0, 0, "slave"},
};
FLASHSTORE _objd SDO1009[] =
{
  {0x0, DTYPE_VISIBLE_STRING, 24, ATYPE_RO, acName1009_0, 0, "1.0"},
};
FLASHSTORE _objd SDO100A[] =
{
  {0x0, DTYPE_VISIBLE_STRING, 24, ATYPE_RO, acName100A_0, 0, "1.0"},
};
FLASHSTORE _objd SDO1018[] =
{
  {0x00, DTYPE_UNSIGNED8, 8, ATYPE_RO, acName1018_00, 4, nil},
  {0x01, DTYPE_UNSIGNED32, 32, ATYPE_RO, acName1018_01, 0xE0001337, nil},
  {0x02, DTYPE_UNSIGNED32, 32, ATYPE_RO, acName1018_02, 1, nil},
  {0x03, DTYPE_UNSIGNED32, 32, ATYPE_RO, acName1018_03, 0, nil},
  {0x04, DTYPE_UNSIGNED32, 32, ATYPE_RO, acName1018_04, 0x00000000, nil},
};
FLASHSTORE _objd SDO1600[] =
{
  {0x00, DTYPE_UNSIGNED8, 8, ATYPE_RO, acName1600_00, 2, nil},
  {0x01, DTYPE_UNSIGNED32, 32, ATYPE_RO, acName1600_01, 0x70000104, nil},
  {0x02, DTYPE_UNSIGNED32, 32, ATYPE_RO, acName1600_02, 0x00000004, nil},
};
FLASHSTORE _objd SDO1A00[] =
{
  {0x00, DTYPE_UNSIGNED8, 8, ATYPE_RO, acName1A00_00, 3, nil},
  {0x01, DTYPE_UNSIGNED32, 32, ATYPE_RO, acName1A00_01, 0x60000102, nil},
  {0x02, DTYPE_UNSIGNED32, 32, ATYPE_RO, acName1A00_02, 0x00000006, nil},
  {0x03, DTYPE_UNSIGNED32, 32, ATYPE_RO, acName1A00_03, 0x60000220, nil},
};
FLASHSTORE _objd SDO1C00[] =
{
  {0x00, DTYPE_UNSIGNED8, 8, ATYPE_RO, acName1C00_00, 4, nil},
  {0x01, DTYPE_UNSIGNED8, 8, ATYPE_RO, acName1C00_01, 1, nil},
  {0x02, DTYPE_UNSIGNED8, 8, ATYPE_RO, acName1C00_02, 2, nil},
  {0x03, DTYPE_UNSIGNED8, 8, ATYPE_RO, acName1C00_03, 3, nil},
  {0x04, DTYPE_UNSIGNED8, 8, ATYPE_RO, acName1C00_04, 4, nil},
};
FLASHSTORE _objd SDO1C12[] =
{
  {0x00, DTYPE_UNSIGNED8, 8, ATYPE_RO, acName1C12_00, 1, nil},
  {0x01, DTYPE_UNSIGNED16, 16, ATYPE_RO, acName1C12_01, 0x1600, nil},
};
FLASHSTORE _objd SDO1C13[] =
{
  {0x00, DTYPE_UNSIGNED8, 8, ATYPE_RO, acName1C13_00, 1, nil},
  {0x01, DTYPE_UNSIGNED16, 16, ATYPE_RO, acName1C13_01, 0x1A00, nil},
};
FLASHSTORE _objd SDO6000[] =
{
  {0x00, DTYPE_UNSIGNED8, 8, ATYPE_RO, acName6000_00, 2, nil},
  {0x01, DTYPE_BIT2, 2, ATYPE_RO, acName6000_01, 0, &Rb.buttons},
  {0x02, DTYPE_UNSIGNED32, 32, ATYPE_RO, acName6000_02, 0, &Rb.heartbeat},
};
FLASHSTORE _objd SDO7000[] =
{
  {0x00, DTYPE_UNSIGNED8, 8, ATYPE_RO, acName7000_00, 1, nil},
  {0x01, DTYPE_BIT4, 4, ATYPE_RO, acName7000_01, 0, &Wb.leds},
};

FLASHSTORE _objectlist SDOobjects[] =
{
  {0x1000, OTYPE_VAR, 0, 0, acName1000, SDO1000},
  {0x1008, OTYPE_VAR, 0, 0, acName1008, SDO1008},
  {0x1009, OTYPE_VAR, 0, 0, acName1009, SDO1009},
  {0x100A, OTYPE_VAR, 0, 0, acName100A, SDO100A},
  {0x1018, OTYPE_RECORD, 4, 0, acName1018, SDO1018},
  {0x1600, OTYPE_RECORD, 2, 0, acName1600, SDO1600},
  {0x1A00, OTYPE_RECORD, 3, 0, acName1A00, SDO1A00},
  {0x1C00, OTYPE_ARRAY, 4, 0, acName1C00, SDO1C00},
  {0x1C12, OTYPE_ARRAY, 1, 0, acName1C12, SDO1C12},
  {0x1C13, OTYPE_ARRAY, 1, 0, acName1C13, SDO1C13},
  {0x6000, OTYPE_RECORD, 2, 0, acName6000, SDO6000},
  {0x7000, OTYPE_RECORD, 1, 0, acName7000, SDO7000},
  {0xffff, 0xff, 0xff, 0xff, nil, nil}
};

#endif
