#ifndef __SOES_H__
#define __SOES_H__

#include "utypes.h"

extern _Rbuffer Rb;
extern _Wbuffer Wb;
extern _Cbuffer Cb;

/**
 * This function reads the physical input "Buttons" and assigns 
 * a value to the variable Rb.buttons.
 */
void cb_get_buttons();

/**
 * This function reads the physical input "Heartbeat" and assigns 
 * a value to the variable Rb.heartbeat.
 */
void cb_get_heartbeat();

/**
 * This function writes the physical output "LEDS" using the value 
 * of the variable Wb.leds.
 */
void cb_set_leds();

/**
 * This function is called after a SDO write of the variable leds.
 */
void cb_post_write_leds();

/**
 * This function sets an application loop callback function.
 */
void set_application_loop_hook(void (*callback)(void));

/**
 * Main function for SOES application
 */
void soes (void);

/**
 * Initialize the SOES stack
 */
void soes_init (void);

#endif /* SOES_H */